package com.zh.lingnuo.controller;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.dysmsapi20170525.Client;
import com.zh.lingnuo.utils.Common;
import com.zh.lingnuo.utils.FuncRes;
import com.zh.lingnuo.utils.SmsService;
import com.zh.lingnuo.utils.result.HttpStatusEnum;
import com.zh.lingnuo.utils.result.Result;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

@Tag(name = "工具中心")
@RestController
@RequestMapping("/util")
public class UtilController {

    @Value("${web.uploadPath}")
    private String path;
    @Value("${web.picSizeLimit}")
    private long picSizeLimit;
//    @Value("${web.cdn}")
//    private String cdn;

    @Operation(summary = "上传")
    @PostMapping("/upload")
    @ResponseBody
    public Result upload(@RequestParam("file") MultipartFile file, @RequestParam(required = false) String name) {
        if (file.isEmpty()) {
            return Result.fail(HttpStatusEnum.CUSTOM_EXCEPTION, "请选择文件");
        }
        String fileName = file.getOriginalFilename();//文件名
        LocalDateTime time = LocalDateTime.now();
        String randomName = Common.md5(String.valueOf(time))+Common.getRandomString(4,"");
//        String randomName = UUID.randomUUID().toString().replace("-", "") + LocalDateTime.now().toInstant(ZoneOffset.ofHours(8)).toEpochMilli();
        String newFileName = randomName + fileName.substring(fileName.lastIndexOf("."));
        JSONObject res = new JSONObject();
        try {
            String filePath = path + "/" +time.format(DateTimeFormatter.ofPattern("YYYYMMdd"))+"/"+ newFileName;
            File dest = new File(filePath);
            if (!dest.getParentFile().exists()) {
                dest.getParentFile().mkdirs();
            }
            file.transferTo(dest);
            res.put("fileUrl", "/upload/" + newFileName);
            res.put("fileName", fileName);
            return Result.success(res, "上传完成");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return Result.fail(HttpStatusEnum.CUSTOM_EXCEPTION, "上传失败");
    }

    public static void main(String[] args) {
        String[] arr = {"a"};
        String join = String.join(",", arr);
System.out.println(join);
        String[] split = join.split(",");
        System.out.println(split[0]);
    }
}
