package com.zh.lingnuo.mapper;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.lingnuo.model.CompanyQn;
import com.zh.lingnuo.model.CompanyQnAnswer;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.zh.lingnuo.model.QnGroup;
import lombok.Data;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-09-13
 */
public interface CompanyQnAnswerMapper extends BaseMapper<CompanyQnAnswer> {

    @Data
    public static class MapperResultAnswerAll {
        private Integer id;
        private Integer qnId;
        private Integer titleId;
        private String title;
        private Integer titleKind;
        private String answerOpt;
        private String answerCont;
        private Integer qnTowardsId;
    }

    @Select(" SELECT t1.*,t2.kind as titleKind FROM company_qn_answer as t1 " +
        "left join company_qn_title as t2 on t1.title_id= t2.id " +
        "${ew.customSqlSegment}")
    List<MapperResultAnswerAll> answerList(@Param("ew") Wrapper<CompanyQnAnswer> qw);

    @Data
    public static class MapperAnswererResult {
        private Integer id;
        private Integer qnId;
        private Integer titleId;
        private String title;
        private Integer answererId;
        private String answererName;
        private Integer qnTowardsId;
        private String qnTowardsName;
        private String answerOpt;
        private String answerCont;
    }

    @Select("    SELECT t1.*,t3.name as answererName,t4.name as qnTowardsName\n" +
        "    FROM company_qn_answer as t1\n" +
        "    left join company_qn_title as t2 on t1.title_id= t2.id\n" +
        "    left join answerer as t3 on t1.answerer_id = t3.id\n" +
        "    left join answerer as t4 on t1.qn_towards_id = t4.id\n" +
        "    ${ew.customSqlSegment}")
    List<MapperAnswererResult> answererResult(@Param("ew") Wrapper<CompanyQnAnswer> qw);
}
