package com.zh.lingnuo.mapper;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.zh.lingnuo.model.CompanyQnAnswer;
import com.zh.lingnuo.model.CompanyQnAnswerer;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

import java.time.LocalDateTime;
import java.util.List;
import lombok.Data;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-09-14
 */
public interface CompanyQnAnswererMapper extends BaseMapper<CompanyQnAnswerer> {

    @Data
    public static class MapperResultQnAnswererAll {
        private Integer id;
        private Integer qnId;
        private Integer answererId;
        private Integer companyId;
        private String name;
        private String mail;
        private String tel;
        private Integer workAge;
        private Integer departmentId;
        private String department;
        private String salt;
        private String password;
        private Integer status;
        private LocalDateTime startedAt;
        private LocalDateTime finishedAt;
        private LocalDateTime updatedAt;
        private LocalDateTime createdAt;
    }

    @Select("SELECT * FROM company_qn_answerer as t1 " +
        "LEFT JOIN answerer as t2 on t1.answerer_id = t2.id " +
        "${ew.customSqlSegment}")
    List<MapperResultQnAnswererAll> qnAnswererList(@Param("ew") Wrapper<CompanyQnAnswerer> qw);

    @Select("SELECT answerer_id FROM company_qn_answerer where qn_id = #{qnId}")
    List<Integer> answererIdList(int qnId);

    @Select("SELECT \n" +
        "IF(\n" +
        "(SELECT GROUP_CONCAT(id ORDER BY id) from company_qn_title WHERE qn_id = #{qnId} )\n" +
        "= \n" +
        "(SELECT GROUP_CONCAT(DISTINCT title_id ORDER BY title_id)\tFROM company_qn_answer  WHERE qn_id = #{qnId} and answerer_id = #{answererId} )\n" +
        " ,1,0)\n" +
        "as result")
    int isFinished(int qnId,int answererId);

}
