package com.zh.lingnuo.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.lingnuo.model.QnTitle;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import lombok.Data;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.time.LocalDateTime;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-09-13
 */
public interface QnTitleMapper extends BaseMapper<QnTitle> {

    @Data
    public static class MapperResultTitleList{
        private int id;
        private String title;
        private Integer kind;
        private Integer gpId;
        private String groupName;
        private String tag;
        private int status;
        private String options;
        private String statusName;
        private LocalDateTime updatedAt;
        private LocalDateTime createdAt;
    }

    @Select("select t1.*,t2.id as gpId ,t2.title as groupName from qn_title as t1 " +
        "left join qn_group as t2 on t1.group_id = t2.id " +
        "${ew.customSqlSegment}")
    IPage<MapperResultTitleList> list(IPage page, @Param("ew")Wrapper<QnTitle> qw);
}
