package com.zh.lingnuo.model;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.util.List;

import com.zh.lingnuo.controller.company.CompanyQnController;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author zh
 * @since 2022-09-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class CompanyQn extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 企业id
     */
    private Integer companyId;

    @TableField(exist = false)
    private String companyName;

    private String title;

    private String subtitle;

    /**
     * 0=未投放 1 =投放中 2=已结束
     */
    private Integer status;

    /**
     * 0=非匿名 1= 匿名
     */
    private Integer isSecret;

    private LocalDateTime releaseAt;

    private LocalDateTime endAt;

    @TableField(fill = FieldFill.INSERT_UPDATE)
    private LocalDateTime updatedAt;

    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createdAt;

    /**  未发布 */
    public static int CompanyQnStatusNotRelease = 0;
    /**  投放中 */
    public static int CompanyQnStatusRelease = 1;
    /**  已结束 */
    public static int CompanyQnStatusEnd = 2;

    public static String getStatusName(int status) {
        switch (status) {
            case 0:
                return "未发布";
            case 1:
                return "投放中";
            case 2:
                return "已结束";
            default:
                return "未知";
        }
    }

    public static String getIsSecretDesc(int isSecret) {
        switch (isSecret) {
            case 0:
                return "非匿名";
            case 1:
                return "匿名";
            default:
                return "未知";
        }
    }

}
