package com.zh.lingnuo.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.lingnuo.controller.answerer.CompanyQnAnswerController;
import com.zh.lingnuo.model.CompanyQnAnswer;
import com.baomidou.mybatisplus.extension.service.IService;
import com.zh.lingnuo.utils.result.Result;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletResponse;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author zh
 * @since 2022-09-13
 */
public interface ICompanyQnAnswerService extends IService<CompanyQnAnswer> {

    // 问卷列表
    Result qnList(CompanyQnAnswerController.paramsAnswererQnList params, int answererId);

    // 答题结果
    Result all(int qnId, int answererId);

    // 全部被评人
    Result allQnTowards(int qnId, int answererId);

    // 答题
    Result add(CompanyQnAnswerController.paramsCompanyQnAnswerAdd params);

    // 结束答题
    Result end(int qnId, int answererId);

    // 答题人互评详情
    Result partnerChoiceResult(IPage page, int qnId, boolean isManage);

    // 答题人互评结果导出Excel
    void resultExportExcel(HttpServletResponse response,int qnId,boolean isManage);
}
