package com.zh.lingnuo.serviceImpl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zh.lingnuo.controller.manage.UserController;
import com.zh.lingnuo.mapper.UserMapper;
import com.zh.lingnuo.model.User;
import com.zh.lingnuo.service.IUserService;
import com.zh.lingnuo.utils.Common;
import com.zh.lingnuo.utils.result.Result;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author zh
 * @since 2022-09-08
 */
@Service
public class UserServiceImpl extends ServiceImpl<UserMapper, User> implements IUserService {

    // 添加用户
    public Result addUser(UserController.ParamsAddUser params) {
        if (super.getOne(new QueryWrapper<User>()
            .eq("name", params.getName()).or().eq("phone", params.getPhone())
            .last("limit 1")) != null) {
            return Result.err("姓名或手机号已存在");
        }
        String salt = Common.getRandomString(6, "");
        String password = Common.md5(salt + Common.md5(params.getPassword() + salt));
        super.save(
            new User().setName(params.getName())
                .setPhone(params.getPhone())
                .setMail(params.getMail())
                .setLevel(params.getLevel())
                .setSalt(salt)
                .setPassword(password));
        return Result.success();
    }
}
